Package ghidra.program.model.lang

# Class BasicLanguageDescription

java.lang.Object
ghidra.program.model.lang.BasicLanguageDescription

All Implemented Interfaces:
  `LanguageDescription`

Direct Known Subclasses:
  `SleighLanguageDescription`

public class BasicLanguageDescription extends Object implements LanguageDescription

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BasicLanguageDescription(LanguageID id, Processor processor, Endian endian, Endian instructionEndian, int size, String variant, String description, int version, int minorVersion, boolean deprecated, CompilerSpecDescription compilerSpec, Map<String,List<String>> externalNames)`
  `BasicLanguageDescription(LanguageID id, Processor processor, Endian endian, Endian instructionEndian, int size, String variant, String description, int version, int minorVersion, boolean deprecated, List<CompilerSpecDescription> compilerSpecs, Map<String,List<String>> externalNames)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object obj)`
  `List<CompilerSpecDescription>`
  `getCompatibleCompilerSpecDescriptions()`
  `CompilerSpecDescription`
  `getCompilerSpecDescriptionByID(CompilerSpecID compilerSpecID)`
  `String`
  `getDescription()`
  `Endian`
  `getEndian()`
  `List<String>`
  `getExternalNames(String key)`
  Returns external names for this language associated with other tools.
  `Endian`
  `getInstructionEndian()`
  `LanguageID`
  `getLanguageID()`
  `int`
  `getMinorVersion()`
  `Processor`
  `getProcessor()`
  `int`
  `getSize()`
  `String`
  `getVariant()`
  `int`
  `getVersion()`
  `int`
  `hashCode()`
  `boolean`
  `isDeprecated()`
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### BasicLanguageDescription

    public BasicLanguageDescription(LanguageID id, Processor processor, Endian endian, Endian instructionEndian, int size, String variant, String description, int version, int minorVersion, boolean deprecated, CompilerSpecDescription compilerSpec, Map<String,List<String>> externalNames)

  - ### BasicLanguageDescription

    public BasicLanguageDescription(LanguageID id, Processor processor, Endian endian, Endian instructionEndian, int size, String variant, String description, int version, int minorVersion, boolean deprecated, List<CompilerSpecDescription> compilerSpecs, Map<String,List<String>> externalNames)

- ## Method Details

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(Object obj)
    Overrides:
      `equals` in class `Object`

  - ### getDescription

    public String getDescription()
    Specified by:
      `getDescription` in interface `LanguageDescription`

  - ### getEndian

    public Endian getEndian()
    Specified by:
      `getEndian` in interface `LanguageDescription`

  - ### getInstructionEndian

    public Endian getInstructionEndian()
    Specified by:
      `getInstructionEndian` in interface `LanguageDescription`

  - ### getLanguageID

    public LanguageID getLanguageID()
    Specified by:
      `getLanguageID` in interface `LanguageDescription`

  - ### getMinorVersion

    public int getMinorVersion()
    Specified by:
      `getMinorVersion` in interface `LanguageDescription`

  - ### getVersion

    public int getVersion()
    Specified by:
      `getVersion` in interface `LanguageDescription`

  - ### getProcessor

    public Processor getProcessor()
    Specified by:
      `getProcessor` in interface `LanguageDescription`

  - ### getSize

    public int getSize()
    Specified by:
      `getSize` in interface `LanguageDescription`

  - ### getVariant

    public String getVariant()
    Specified by:
      `getVariant` in interface `LanguageDescription`

  - ### isDeprecated

    public boolean isDeprecated()
    Specified by:
      `isDeprecated` in interface `LanguageDescription`

  - ### getCompatibleCompilerSpecDescriptions

    public List<CompilerSpecDescription> getCompatibleCompilerSpecDescriptions()
    Specified by:
      `getCompatibleCompilerSpecDescriptions` in interface `LanguageDescription`

  - ### getCompilerSpecDescriptionByID

    public CompilerSpecDescription getCompilerSpecDescriptionByID(CompilerSpecID compilerSpecID) throws CompilerSpecNotFoundException
    Specified by:
      `getCompilerSpecDescriptionByID` in interface `LanguageDescription`
    Throws:
      `CompilerSpecNotFoundException`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### getExternalNames

    public List<String> getExternalNames(String key)
    Description copied from interface: `LanguageDescription`
    Returns external names for this language associated with other tools. For example, x86 languages are usually referred to as "metapc" by IDA-PRO. So, getExternalNames("IDA-PRO") will return "metapc" for most x86 languages.
    Specified by:
      `getExternalNames` in interface `LanguageDescription`
    Parameters:
      `key` - external tool for looking up external tool names
    Returns:
      external names for this language associated with tool 'key' -- null if there are no results